hira_to_kata = {
   "あ": "ア",
   "い": "イ",
   "う": "ウ",
   "え": "エ",
   "お": "オ",
   "か": "カ",
   "き": "キ",
   "く": "ク",
   "け": "ケ",
   "こ": "コ",
   "さ": "サ",
   "し": "シ",
   "す": "ス",
   "せ": "セ",
   "そ": "ソ",
   "た": "タ",
   "ち": "チ",
   "つ": "ツ",
   "て": "テ",
   "と": "ト",
   "な": "ナ",
   "に": "ニ",
   "ぬ": "ヌ",
   "ね": "ネ",
   "の": "ノ",
   "は": "ハ",
   "ひ": "ヒ",
   "ふ": "フ",
   "へ": "ヘ",
   "ほ": "ホ",
   "ま": "マ",
   "み": "ミ",
   "む": "ム",
   "め": "メ",
   "も": "モ",
   "や": "ヤ",
   "ゆ": "ユ",
   "よ": "ヨ",
   "ら": "ラ",
   "り": "リ",
   "る": "ル",
   "れ": "レ",
   "ろ": "ロ",
   "わ": "ワ",
   "を": "ヲ",
   "ん": "ン",
}

kana_to_romaji = {
   "ヴョ": "byo",
   "ヴュ": "byu",
   "ヴャ": "bya",
   "ヴォ": "vo",
   "ヴェ": "ve",
   "ヴィ": "vi",
   "ヴァ": "va",
   "ヴ": "vu",
   "ン": "N",
   "ヲ": "o",
   "ヱ": "e",
   "ヰ": "i",
   "ワ": "wa",
   "ヮ": "wa",
   "ロ": "ro",
   "レ": "re",
   "ル": "ru",
   "リョ": "ryo",
   "リュ": "ryu",
   "リャ": "rya",
   "リェ": "rye",
   "リ": "ri",
   "ラ": "ra",
   "ヨ": "yo",
   "ョ": "yo",
   "ユ": "yu",
   "ュ": "yu",
   "ヤ": "ya",
   "ャ": "ya",
   "モ": "mo",
   "メ": "me",
   "ム": "mu",
   "ミョ": "myo",
   "ミュ": "myu",
   "ミャ": "mya",
   "ミェ": "mye",
   "ミ": "mi",
   "マ": "ma",
   "ポ": "po",
   "ボ": "bo",
   "ホ": "ho",
   "ペ": "pe",
   "ベ": "be",
   "ヘ": "he",
   "プ": "pu",
   "ブ": "bu",
   "フォ": "fo",
   "フェ": "fe",
   "フィ": "fi",
   "ファ": "fa",
   "フ": "fu",
   "ピョ": "pyo",
   "ピュ": "pyu",
   "ピャ": "pya",
   "ピェ": "pye",
   "ピ": "pi",
   "ビョ": "byo",
   "ビュ": "byu",
   "ビャ": "bya",
   "ビェ": "bye",
   "ビ": "bi",
   "ヒョ": "hyo",
   "ヒュ": "hyu",
   "ヒャ": "hya",
   "ヒェ": "hye",
   "ヒ": "hi",
   "パ": "pa",
   "バ": "ba",
   "ハ": "ha",
   "ノ": "no",
   "ネ": "ne",
   "ヌ": "nu",
   "ニョ": "no",
   "ニュ": "nyu",
   "ニャ": "nya",
   "ニェ": "nye",
   "ニ": "ni",
   "ナ": "na",
   "ドゥ": "du",
   "ド": "do",
   "トゥ": "tu",
   "ト": "to",
   "デョ": "dyo",
   "デュ": "dyu",
   "デャ": "dya",
   "ディ": "di",
   "デ": "de",
   "テョ": "tyo",
   "テュ": "tyu",
   "テャ": "tya",
   "ティ": "ti",
   "テ": "te",
   "ヅ": "zu",
   "ツォ": "tso",
   "ツェ": "tse",
   "ツィ": "tsi",
   "ツァ": "tsa",
   "ツ": "tsu",
   "ッ": "T",
   "ヂ": "ji",
   "チョ": "cho",
   "チュ": "chu",
   "チャ": "cha",
   "チェ": "che",
   "チ": "chi",
   "ダ": "da",
   "タ": "ta",
   "ゾ": "zo",
   "ソ": "so",
   "ゼ": "ze",
   "セ": "se",
   "ズィ": "zi",
   "ズ": "zu",
   "スィ": "si",
   "ス": "su",
   "ジョ": "jo",
   "ジュ": "ju",
   "ジャ": "ja",
   "ジェ": "je",
   "ジ": "ji",
   "ショ": "sho",
   "シュ": "shu",
   "シャ": "sha",
   "シェ": "she",
   "シ": "shi",
   "ザ": "za",
   "サ": "sa",
   "ゴ": "go",
   "コ": "ko",
   "ゲ": "ge",
   "ケ": "ke",
   "ヶ": "ke",
   "グヮ": "gwa",
   "グ": "gu",
   "クヮ": "kwa",
   "ク": "ku",
   "ギョ": "gyo",
   "ギュ": "gyu",
   "ギャ": "gya",
   "ギェ": "gye",
   "ギ": "gi",
   "キョ": "kyo",
   "キュ": "kyu",
   "キャ": "kya",
   "キェ": "kye",
   "キ": "ki",
   "ガ": "ga",
   "カ": "ka",
   "オ": "o",
   "ォ": "o",
   "エ": "e",
   "ェ": "e",
   "ウォ": "wo",
   "ウェ": "we",
   "ウィ": "wi",
   "ウ": "u",
   "ゥ": "u",
   "イェ": "ye",
   "イ": "i", 
   "ィ": "i", 
   "ア": "a",
   "ァ": "a", 
   ":": "|",
   "ー": ":",
   "、": ",",
   "。": ".",
   "！": "!",
   "？": "?",
}

vowels_romaji = ["a", "i", "u", "e", "o", "T", "N", "A", "I", "U", "E", "O", ":"]

kana_to_ipa = {
   "ヴョ": "bʲo",
   "ヴュ": "bʲɯ",
   "ヴャ": "bʲa",
   "ヴォ": "vo",
   "ヴェ": "ve",
   "ヴィ": "vi",
   "ヴァ": "va",
   "ヴ": "vɯ",
   "ン": "N",
   "ヲ": "o",
   "ヱ": "e",
   "ヰ": "i",
   "ワ": "wa",
   "ヮ": "wa",
   "ロ": "ɾo",
   "レ": "ɾe",
   "ル": "ɾɯ",
   "リョ": "ɾʲo",
   "リュ": "ɾʲɯ",
   "リャ": "ɾʲa",
   "リェ": "ɾʲe",
   "リ": "ɾi",
   "ラ": "ɾa",
   "ヨ": "jo",
   "ョ": "jo",
   "ユ": "jɯ",
   "ュ": "jɯ",
   "ヤ": "ja",
   "ャ": "ja",
   "モ": "mo",
   "メ": "me",
   "ム": "mɯ",
   "ミョ": "mʲo",
   "ミュ": "mʲɯ",
   "ミャ": "mʲa",
   "ミェ": "mʲe",
   "ミ": "mi",
   "マ": "ma",
   "ポ": "po",
   "ボ": "bo",
   "ホ": "ho",
   "ペ": "pe",
   "ベ": "be",
   "ヘ": "he",
   "プ": "pɯ",
   "ブ": "bɯ",
   "フォ": "ɸo",
   "フェ": "ɸe",
   "フィ": "ɸi",
   "ファ": "ɸa",
   "フ": "ɸɯ",
   "ピョ": "pʲo",
   "ピュ": "pʲɯ",
   "ピャ": "pʲa",
   "ピェ": "pʲe",
   "ピ": "pi",
   "ビョ": "bʲo",
   "ビュ": "bʲɯ",
   "ビャ": "bʲa",
   "ビェ": "bʲe",
   "ビ": "bi",
   "ヒョ": "ço",
   "ヒュ": "çɯ",
   "ヒャ": "ça",
   "ヒェ": "çe",
   "ヒ": "çi",
   "パ": "pa",
   "バ": "ba",
   "ハ": "ha",
   "ノ": "no",
   "ネ": "ne",
   "ヌ": "nɯ",
   "ニョ": "ɲo",
   "ニュ": "ɲɯ",
   "ニャ": "ɲa",
   "ニェ": "ɲe",
   "ニ": "ɲi",
   "ナ": "na",
   "ドゥ": "dɯ",
   "ド": "do",
   "トゥ": "tɯ",
   "ト": "to",
   "デョ": "dʲo",
   "デュ": "dʲɯ",
   "デャ": "dʲa",
   "ディ": "di",
   "デ": "de",
   "テョ": "tʲo",
   "テュ": "tʲɯ",
   "テャ": "tʲa",
   "ティ": "ti",
   "テ": "te",
   "ヅ": "dzɯ",
   "ツォ": "tso",
   "ツェ": "tse",
   "ツィ": "tsi",
   "ツァ": "tsa",
   "ツ": "tsɯ",
   "ッ": "Q",
   "ヂ": "dʑi",
   "チョ": "tɕo",
   "チュ": "tɕɯ",
   "チャ": "tɕa",
   "チェ": "tɕe",
   "チ": "tɕi",
   "ダ": "da",
   "タ": "ta",
   "ゾ": "dzo",
   "ソ": "so",
   "ゼ": "dze",
   "セ": "se",
   "ズィ": "dzi",
   "ズ": "dzɯ",
   "スィ": "si",
   "ス": "sɯ",
   "ジョ": "do",
   "ジュ": "dʑɯ",
   "ジャ": "dʑa",
   "ジェ": "dʑe",
   "ジ": "dʑi",
   "ショ": "ɕo",
   "シュ": "ɕɯ",
   "シャ": "ɕa",
   "シェ": "ɕe",
   "シ": "ɕi",
   "ザ": "dza",
   "サ": "sa",
   "ゴ": "go",
   "コ": "ko",
   "ゲ": "ge",
   "ケ": "ke",
   "ヶ": "ke",
   "グヮ": "gwa",
   "グ": "gɯ",
   "クヮ": "kwa",
   "ク": "kɯ",
   "ギョ": "gʲo",
   "ギュ": "gʲɯ",
   "ギャ": "gʲa",
   "ギェ": "gʲe",
   "ギ": "gi",
   "キョ": "kʲo",
   "キュ": "kʲɯ",
   "キャ": "kʲa",
   "キェ": "kʲe",
   "キ": "ki",
   "ガ": "ga",
   "カ": "ka",
   "オ": "o",
   "ォ": "o",
   "エ": "e",
   "ェ": "e",
   "ウォ": "wo",
   "ウェ": "we",
   "ウィ": "wi",
   "ウ": "ɯ",
   "ゥ": "ɯ",
   "イェ": "je",
   "イ": "i", 
   "ィ": "i", 
   "ア": "a",
   "ァ": "a", 
   ":": "|",
   "ー": ":",
   "、": ",",
   "。": ".",
   "！": "!",
   "？": "?"
}

vowels_ipa = ["a", "i", "ɯ", "e", "o", "N", "Q", ":"]

# TODO: 弁 is a special case
new_to_old = {
   "亜": "亞",
   "悪": "惡",
   "圧": "壓",
   "囲": "圍",
   "為": "爲",
   "医": "醫",
   "壱": "壹",
   "逸": "逸",
   "稲": "稻",
   "飲": "飮",
   "隠": "隱",
   "羽": "羽",
   "営": "營",
   "栄": "榮",
   "衛": "衞",
   "鋭": "銳",
   "益": "益",
   "駅": "驛",
   "悦": "悅",
   "謁": "謁",
   "閲": "閱",
   "円": "圓",
   "縁": "緣",
   "艶": "艷",
   "塩": "鹽",
   "奥": "奧",
   "応": "應",
   "横": "橫",
   "欧": "歐",
   "殴": "毆",
   "黄": "黃",
   "温": "溫",
   "穏": "穩",
   "仮": "假",
   "価": "價",
   "禍": "禍",
   "画": "畫",
   "会": "會",
   "回": "囘",
   "壊": "壞",
   "悔": "悔",
   "懐": "懷",
   "海": "海",
   "絵": "繪",
   "慨": "慨",
   "概": "槪",
   "拡": "擴",
   "殻": "殼",
   "覚": "覺",
   "学": "學",
   "岳": "嶽",
   "楽": "樂",
   "喝": "喝",
   "渇": "渴",
   "褐": "褐",
   "鎌": "鐮",
   "勧": "勸",
   "巻": "卷",
   "寛": "寬",
   "歓": "歡",
   "漢": "漢",
   "缶": "罐",
   "観": "觀",
   "間": "閒",
   "関": "關",
   "陥": "陷",
   "館": "館",
   "巌": "巖",
   "顔": "顏",
   "器": "器",
   "既": "旣",
   "帰": "歸",
   "気": "氣",
   "祈": "祈",
   "亀": "龜",
   "偽": "僞",
   "戯": "戲",
   "犠": "犧",
   "却": "卻",
   "糾": "糺",
   "旧": "舊",
   "拠": "據",
   "挙": "擧",
   "虚": "虛",
   "峡": "峽",
   "挟": "挾",
   "教": "敎",
   "強": "强",
   "狭": "狹",
   "郷": "鄕",
   "響": "響",
   "尭": "堯",
   "暁": "曉",
   "勤": "勤",
   "謹": "謹",
   "区": "區",
   "駆": "驅",
   "勲": "勳",
   "薫": "薰",
   "群": "羣",
   "契": "契",
   "径": "徑",
   "恵": "惠",
   "掲": "揭",
   "携": "攜",
   "渓": "溪",
   "経": "經",
   "継": "繼",
   "茎": "莖",
   "蛍": "螢",
   "軽": "輕",
   "鶏": "鷄",
   "芸": "藝",
   "撃": "擊",
   "欠": "缺",
   "倹": "儉",
   "剣": "劍",
   "圏": "圈",
   "検": "檢",
   "権": "權",
   "献": "獻",
   "県": "縣",
   "研": "硏",
   "険": "險",
   "顕": "顯",
   "験": "驗",
   "厳": "嚴",
   "戸": "戶",
   "呉": "吳",
   "娯": "娛",
   "効": "效",
   "広": "廣",
   "恒": "恆",
   "鉱": "鑛",
   "号": "號",
   "国": "國",
   "穀": "穀",
   "黒": "黑",
   "歳": "歲",
   "済": "濟",
   "砕": "碎",
   "斎": "齋",
   "剤": "劑",
   "冴": "冱",
   "桜": "櫻",
   "冊": "册",
   "殺": "殺",
   "雑": "雜",
   "産": "產",
   "参": "參",
   "惨": "慘",
   "桟": "棧",
   "蚕": "蠶",
   "賛": "贊",
   "残": "殘",
   "祉": "祉",
   "姉": "姊",
   "糸": "絲",
   "視": "視",
   "飼": "飼",
   "歯": "齒",
   "児": "兒",
   "辞": "辭",
   "湿": "濕",
   "実": "實",
   "舎": "舍",
   "写": "寫",
   "煮": "煮",
   "社": "社",
   "者": "者",
   "釈": "釋",
   "寿": "壽",
   "収": "收",
   "臭": "臭",
   "従": "從",
   "渋": "澁",
   "獣": "獸",
   "縦": "縱",
   "祝": "祝",
   "粛": "肅",
   "処": "處",
   "暑": "暑",
   "緒": "緖",
   "署": "署",
   "諸": "諸",
   "叙": "敍",
   "尚": "尙",
   "奨": "奬",
   "将": "將",
   "床": "牀",
   "渉": "涉",
   "焼": "燒",
   "祥": "祥",
   "称": "稱",
   "証": "證",
   "乗": "乘",
   "剰": "剩",
   "壌": "壤",
   "嬢": "孃",
   "条": "條",
   "浄": "淨",
   "状": "狀",
   "畳": "疊",
   "穣": "穰",
   "譲": "讓",
   "醸": "釀",
   "嘱": "囑",
   "触": "觸",
   "寝": "寢",
   "慎": "愼",
   "晋": "晉",
   "真": "眞",
   "神": "神",
   "刃": "刄",
   "尽": "盡",
   "図": "圖",
   "粋": "粹",
   "酔": "醉",
   "随": "隨",
   "髄": "髓",
   "数": "數",
   "枢": "樞",
   "瀬": "瀨",
   "晴": "晴",
   "清": "淸",
   "精": "精",
   "青": "靑",
   "声": "聲",
   "静": "靜",
   "斉": "齊",
   "税": "稅",
   "跡": "蹟",
   "節": "節",
   "説": "說",
   "摂": "攝",
   "窃": "竊",
   "絶": "絕",
   "専": "專",
   "戦": "戰",
   "浅": "淺",
   "潜": "潛",
   "繊": "纖",
   "践": "踐",
   "銭": "錢",
   "禅": "禪",
   "曽": "曾",
   "祖": "祖",
   "僧": "僧",
   "双": "雙",
   "壮": "壯",
   "層": "層",
   "捜": "搜",
   "挿": "插",
   "巣": "巢",
   "争": "爭",
   "痩": "瘦",
   "窓": "窗",
   "総": "總",
   "聡": "聰",
   "荘": "莊",
   "装": "裝",
   "騒": "騷",
   "増": "增",
   "憎": "憎",
   "臓": "臟",
   "蔵": "藏",
   "贈": "贈",
   "即": "卽",
   "属": "屬",
   "続": "續",
   "堕": "墮",
   "体": "體",
   "対": "對",
   "帯": "帶",
   "滞": "滯",
   "台": "臺",
   "滝": "瀧",
   "択": "擇",
   "沢": "澤",
   "琢": "琢",
   "脱": "脫",
   "単": "單",
   "嘆": "嘆",
   "担": "擔",
   "胆": "膽",
   "団": "團",
   "弾": "彈",
   "断": "斷",
   "痴": "癡",
   "遅": "遲",
   "着": "著",
   "昼": "晝",
   "虫": "蟲",
   "鋳": "鑄",
   "猪": "猪",
   "著": "著",
   "庁": "廳",
   "徴": "徵",
   "懲": "懲",
   "聴": "聽",
   "勅": "敕",
   "鎮": "鎭",
   "塚": "塚",
   "逓": "遞",
   "鉄": "鐵",
   "転": "轉",
   "点": "點",
   "伝": "傳",
   "都": "都",
   "党": "黨",
   "盗": "盜",
   "灯": "燈",
   "当": "當",
   "闘": "鬭",
   "闘": "鬪",
   "徳": "德",
   "独": "獨",
   "読": "讀",
   "突": "突",
   "届": "屆",
   "縄": "繩",
   "難": "難",
   "弐": "貳",
   "妊": "姙",
   "粘": "黏",
   "悩": "惱",
   "脳": "腦",
   "覇": "霸",
   "廃": "廢",
   "拝": "拜",
   "梅": "梅",
   "売": "賣",
   "麦": "麥",
   "発": "發",
   "髪": "髮",
   "抜": "拔",
   "繁": "繁",
   "飯": "飯",
   "晩": "晚",
   "蛮": "蠻",
   "卑": "卑",
   "碑": "碑",
   "秘": "祕",
   "彦": "彥",
   "姫": "姬",
   "浜": "濱",
   "賓": "賓",
   "頻": "頻",
   "敏": "敏",
   "瓶": "甁",
   "侮": "侮",
   "福": "福",
   "払": "拂",
   "仏": "佛",
   "併": "倂",
   "塀": "塀",
   "並": "竝",
   "変": "變",
   "辺": "邊",
   "勉": "勉",
   "舗": "舖",
   "歩": "步",
   "穂": "穗",
   "宝": "寶",
   "萌": "萠",
   "褒": "襃",
   "豊": "豐",
   "墨": "墨",
   "没": "沒",
   "翻": "飜",
   "槙": "槇",
   "毎": "每",
   "万": "萬",
   "満": "滿",
   "免": "免",
   "麺": "麵",
   "黙": "默",
   "餅": "餠",
   "戻": "戾",
   "弥": "彌",
   "薬": "藥",
   "訳": "譯",
   "祐": "祐",
   "予": "豫",
   "余": "餘",
   "与": "與",
   "誉": "譽",
   "揺": "搖",
   "様": "樣",
   "謡": "謠",
   "遥": "遙",
   "瑶": "瑤",
   "欲": "慾",
   "来": "來",
   "頼": "賴",
   "乱": "亂",
   "欄": "欄",
   "覧": "覽",
   "略": "畧",
   "隆": "隆",
   "竜": "龍",
   "虜": "虜",
   "旅": "旅",
   "両": "兩",
   "猟": "獵",
   "緑": "綠",
   "隣": "鄰",
   "凛": "凜",
   "塁": "壘",
   "涙": "淚",
   "類": "類",
   "励": "勵",
   "礼": "禮",
   "隷": "隸",
   "霊": "靈",
   "齢": "齡",
   "暦": "曆",
   "歴": "歷",
   "廉": "廉",
   "恋": "戀",
   "練": "練",
   "錬": "鍊",
   "炉": "爐",
   "労": "勞",
   "廊": "廊",
   "朗": "朗",
   "楼": "樓",
   "郎": "郞",
   "禄": "祿",
   "録": "錄",
   "亘": "亙",
   "湾": "灣",
   "弁": "辯",
}

kata_to_manyou = {
   "ア": "阿",
   "イ": "伊",
   "ウ": "宇",
   "エ": "江",
   "オ": "於",
   "カ": "加",
   "キ": "機",
   "ク": "久",
   "ケ": "介",
   "コ": "己",
   "サ": "散",
   "シ": "之",
   "ス": "須",
   "セ": "世",
   "ソ": "曽",
   "タ": "多",
   "チ": "千",
   "ツ": "川",
   "テ": "天",
   "ト": "止",
   "ナ": "奈",
   "ニ": "仁",
   "ヌ": "奴",
   "ネ": "祢",
   "ノ": "乃",
   "ハ": "八",
   "ヒ": "比",
   "フ": "不",
   "ヘ": "部",
   "ホ": "保",
   "マ": "末",
   "ミ": "三",
   "ム": "牟",
   "メ": "女",
   "モ": "毛",
   "ヤ": "也",
   "ユ": "由",
   "ヨ": "輿",
   "ラ": "良",
   "リ": "利",
   "ル": "流",
   "レ": "礼",
   "ロ": "呂",
   "ワ": "和",
   "ヲ": "乎",
   "ン": "尓",
}

small_to_normal = {
   "ァ": "ア",
   "ィ": "イ",
   "ゥ": "ウ",
   "ェ": "エ",
   "ォ": "オ",
   "ヵ": "カ",
   "ヶ": "ケ",
   "ッ": "ツ",
   "ャ": "ヤ",
   "ュ": "ユ",
   "ョ": "ヨ",
   "ヮ": "ワ",
   "ぁ": "あ",
   "ぃ": "い",
   "ぅ": "う",
   "ぇ": "え",
   "ぉ": "お",
   "ゕ": "か",
   "ゖ": "き",
   "っ": "つ",
   "ゃ": "や",
   "ょ": "よ",
   "ゅ": "ゆ",
   "ゎ": "わ",
}












